"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StructuralVariantDetails(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "structuralVariantCoordinates",
        "variantType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "numberOfCopies": reports_6_5_0.NumberOfCopies,
            "structuralVariantCoordinates": reports_6_5_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "variantType": reports_6_5_0.StructuralVariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.NumberOfCopies": reports_6_5_0.NumberOfCopies,
            "org.gel.models.report.avro.Coordinates": reports_6_5_0.Coordinates,
            "org.gel.models.report.avro.StructuralVariantType": reports_6_5_0.StructuralVariantType,
            "org.gel.models.report.avro.StructuralVariantDetails": reports_6_5_0.StructuralVariantDetails,
        }

    __slots__ = [
        "structuralVariantCoordinates",
        "variantType",
        "numberOfCopies",
    ]

    def __init__(
        self,
        structuralVariantCoordinates,
        variantType,
        numberOfCopies=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.StructuralVariantDetails model.

        :param structuralVariantCoordinates:
            Structural variant coordinates
        :type structuralVariantCoordinates: Coordinates
        :param variantType:
            Strctural variant type
        :type variantType: StructuralVariantType
        :param numberOfCopies:
            Number of copies (required for copy number variants)
        :type numberOfCopies: None | list[NumberOfCopies]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
